%range finder data
%for bushnell 1500 rangefinder 
%with sparkfun FTDI basic usb to serial converter
%Andrew Seltzman
%www.rtftechnologies.org

clear all;
close all;
delete(INSTRFIND);
if(fopen('all')~=0)
    fclose(fopen('all'));
end

%set up log files
f=fopen('log.txt','a');
fgood=fopen('goodcommand.txt','a');

%set up serial port
s = serial('COM2','Terminator','CR');
set(s, 'FlowControl', 'none');
set(s, 'DataBits', 8);
set(s, 'Parity', 'none');
set(s, 'StopBit', 1);
set(s, 'BaudRate', 9600);
set(s, 'Timeout',0.5);
s.DataTerminalReady='off';   %power/range button pulled low
fopen(s)

%check if rangefinder is on
CTS=s.PinStatus.ClearToSend;%get status of CTS pin connected to power status
if(strcmp(CTS,'on'))        %cts=on  =0v => rangefinder off
    Power=0;
else                        %cts=off =5v => rangefinder on
    Power=1;
end

%turn on rangefinder
s.DataTerminalReady='off';  %power/range button pulled high
pause(0.2);
s.DataTerminalReady='on';   %power/range button pulled low
pause(0.5);


%range something
s.DataTerminalReady='off';  %power/range button pulled high
pause(1);
s.DataTerminalReady='on';   %power/range button pulled low
pause(1);


%step through all posible input test arguments
visChar=char([0:127]);  %all ascii chars
%visChar=char([33:126]);  %all text ascii chars
%visChar=char([42,44,46,48:57,65:90]);  %cap letters, numberss, comma, *, decimal pt

%header
%header='$PLTIT,RQ,';
header='$';


minlength=1;
maxlength=2;

tic;    %start timer

for (length=minlength:maxlength)

strings=combn([char(visChar)],length); %all combinations of those characters in lenght places
lengthstrings=max(size(strings));
    %step through all string combinations
    for(index=1:lengthstrings)
    
    time=toc;                   %how long since last timer reset
    
    if (time>10)
        s.DataTerminalReady='off';  %power/range button pulled high
        pause(1);
        s.DataTerminalReady='on';   %power/range button pulled low
        pause(1)
        tic;                        %reset timer
    end
    
    %check if rangefinder is on
    CTS=s.PinStatus.ClearToSend;%get status of CTS pin connected to power status
    if(strcmp(CTS,'on'))        %cts=on  =0v => rangefinder off
        Power=0;
    else                        %cts=off =5v => rangefinder on
        Power=1;
    end
    
    %dont send serial data while the rengefinder is off
    while Power==0
        CTS=s.PinStatus.ClearToSend;%get status of CTS pin connected to power status
        if (strcmp(CTS,'on'))
            disp('Hit power button')
            continue
        else
            Power=1;
            pause(0.5);
            break
        end
        
    end
    
    query=[header,strings(index,:)];
    fprintf(s,query); 
    pause(0.015);
    response=fscanf(s);
    
    
    
    logstring=['Power=',num2str(Power),' Computer: ',query,' Rangefinder: ',response];
    disp(logstring);                %disp result to terminal
    fprintf(f,'%s\r\n',logstring);  %log result to file
    
    if(not(strncmp(response,'$ERR,13',7) || strncmp(response,'$ERR,14',7)...
             || strncmp(response,'',1)))
        fprintf(fgood,'%s\r\n',logstring);  %log result to file
    end
    

    end
end

toc;    %stop timer

fclose(f);
fclose(fgood);
%fclose(s);
%delete(s);
%clear s;